/**
 ******************************************************************************
 * @file    mx.c
 * @author  STMicroelectronics - AIS - MCD Team
 * @version 1.0.0
 * @date    Apr 9, 2021
 *
 * @brief Project peripherals configuration files.
 *
 * This files defines the peripherals configuration parameters that can be used
 * in the Low Level API of an eLooM driver - IDrvInit(). It creates a link
 * between the initialization code generated by CubeMX (see the .ioc file
 * in the tools folder) and the eLooM framework.
 *
  ******************************************************************************
  * @attention
  *
  * Copyright (c) 2021 STMicroelectronics
  * All rights reserved.
  *
  * This software is licensed under terms that can be found in the LICENSE file
  * in the root directory of this software component.
  * If no LICENSE file comes with this software, it is provided AS-IS.
  ******************************************************************************
 */

#include "mx.h"
#include "usart.h"
#include "tim.h"
#include "gpio.h"


/**
 * PF6 Initialization parameters.
 */
const MX_GPIOParams_t MX_GPIO_PC13InitParams = {
    MX_GPIO_PC13_Init,
    EXTI13_IRQn,
    GPIO_PIN_13,
    GPIOC
};
